Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/authentication.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/authentication.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/authentication.py	(revision 9169)
@@ -102,4 +102,6 @@
     def checkPassword(self, password):
         """Check whether the given `password` matches the one stored.
+
+        We additionally check if student account has been suspended.
         """
         if not isinstance(password, basestring):
@@ -107,4 +109,6 @@
         if not getattr(self.context, 'password', None):
             # unset/empty passwords do never match
+            return False
+        if self.context.suspended == True:
             return False
         passwordmanager = getUtility(IPasswordManager, 'SSHA')
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/batching.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/batching.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/batching.py	(revision 9169)
@@ -26,4 +26,5 @@
 import grok
 import csv
+from time import time
 from zope.interface import Interface
 from zope.schema import getFields
@@ -42,5 +43,6 @@
     IStudentOnlinePayment, IStudentVerdictUpdate)
 from waeup.kofa.students.workflow import  (
-    IMPORTABLE_STATES, IMPORTABLE_TRANSITIONS)
+    IMPORTABLE_STATES, IMPORTABLE_TRANSITIONS,
+    FORBIDDEN_POSTGRAD_TRANS, FORBIDDEN_POSTGRAD_STATES)
 from waeup.kofa.utils.batching import BatchProcessor
 
@@ -170,4 +172,12 @@
             if transition not in allowed_transitions:
                 return 'Transition not allowed.'
+            if transition in FORBIDDEN_POSTGRAD_TRANS and \
+                obj.is_postgrad:
+                return 'Transition not allowed (pg student).'
+        state = row.get('state', IGNORE_MARKER)
+        if state not in (IGNORE_MARKER, ''):
+            if state in FORBIDDEN_POSTGRAD_STATES and \
+                obj.is_postgrad:
+                return 'State not allowed (pg student).'
         return None
 
@@ -183,4 +193,5 @@
 
         # Update password
+        # XXX: Tale DELETION_MARKER into consideration
         if row.has_key('password'):
             passwd = row.get('password', IGNORE_MARKER)
@@ -222,5 +233,6 @@
         parent = self.getParent(row, site)
         if hasattr(obj,'student_id'):
-            # Update mode: the student exists and we can get the student_id
+            # Update mode: the student exists and we can get the student_id.
+            # Create mode: the record contains the student_id
             parent.logger.info(
                 '%s - Student record updated: %s'
@@ -259,17 +271,16 @@
         errs, inv_errs, conv_dict =  converter.fromStringDict(
             row, self.factory_name, mode=mode)
-        if row.has_key('transition') and \
-            not row['transition'] in IMPORTABLE_TRANSITIONS:
-            if row['transition'] not in (IGNORE_MARKER, ''):
-                errs.append(('transition','not allowed'))
-        if row.has_key('state') and \
-            not row['state'] in IMPORTABLE_STATES:
-            if row['state'] not in (IGNORE_MARKER, ''):
-                errs.append(('state','not allowed'))
-            else:
-                # state is an attribute of Student and must not
-                # be changed if empty
-                conv_dict['state'] = IGNORE_MARKER
-
+        if row.has_key('transition'):
+            if row['transition'] not in IMPORTABLE_TRANSITIONS:
+                if row['transition'] not in (IGNORE_MARKER, ''):
+                    errs.append(('transition','not allowed'))
+        if row.has_key('state'):
+            if row['state'] not in IMPORTABLE_STATES:
+                if row['state'] not in (IGNORE_MARKER, ''):
+                    errs.append(('state','not allowed'))
+                else:
+                    # State is an attribute of Student and must not
+                    # be changed if empty.
+                    conv_dict['state'] = IGNORE_MARKER
         try:
             # Correct stud_id counter. As the IConverter for students
@@ -291,8 +302,9 @@
     grok.baseclass()
 
-    #: required fields beside 'student_id', 'reg_number' and 'matric_number'
+    # additional available  fields
+    # beside 'student_id', 'reg_number' and 'matric_number'
     additional_fields = []
 
-    #: header fields additional required
+    #: header fields additionally required
     additional_headers = []
 
@@ -361,4 +373,21 @@
         return errs, inv_errs, conv_dict
 
+    def getMapping(self, path, headerfields, mode):
+        """Get a mapping from CSV file headerfields to actually used fieldnames.
+        """
+        result = dict()
+        reader = csv.reader(open(path, 'rb'))
+        raw_header = reader.next()
+        for num, field in enumerate(headerfields):
+            if field not in ['student_id', 'reg_number', 'matric_number',
+                             'p_id', 'code', 'level'
+                             ] and mode == 'remove':
+                continue
+            if field == u'--IGNORE--':
+                # Skip ignored columns in failed and finished data files.
+                continue
+            result[raw_header[num]] = field
+        return result
+
 
 class StudentStudyCourseProcessor(StudentProcessorBase):
@@ -406,10 +435,23 @@
             StudentStudyCourseProcessor, self).checkConversion(row, mode=mode)
         # We have to check if current_level is in range of certificate.
-        if conv_dict.has_key('certificate'):
-          cert = conv_dict['certificate']
-          if conv_dict['current_level'] < cert.start_level or \
-              conv_dict['current_level'] > cert.end_level+120:
-              errs.append(('current_level','not in range'))
+        if conv_dict.has_key('certificate') and \
+            conv_dict.has_key('current_level'):
+            cert = conv_dict['certificate']
+            level = conv_dict['current_level']
+            if level < cert.start_level or level > cert.end_level+120:
+                errs.append(('current_level','not in range'))
         return errs, inv_errs, conv_dict
+
+    def checkUpdateRequirements(self, obj, row, site):
+        """Checks requirements the object must fulfill when being updated.
+
+        Returns error messages as strings in case of requirement
+        problems.
+        """
+        current_level = row.get('current_level', None)
+        if current_level == 999 and \
+            obj.__parent__.state in FORBIDDEN_POSTGRAD_STATES:
+            return 'Not a pg student.'
+        return None
 
 class StudentStudyLevelProcessor(StudentProcessorBase):
@@ -427,4 +469,5 @@
 
     location_fields = []
+
     additional_fields = ['level']
     additional_headers = ['level']
@@ -509,8 +552,9 @@
         items_changed = super(CourseTicketProcessor, self).updateEntry(
             obj, row, site)
+        parent = self.getParent(row, site)
         student = self.getParent(row, site).__parent__.__parent__
         student.__parent__.logger.info(
-            '%s - Course ticket updated: %s'
-            % (student.student_id, items_changed))
+            '%s - Course ticket in %s updated: %s'
+            % (student.student_id,  parent.level, items_changed))
         return
 
@@ -528,4 +572,14 @@
         return
 
+    def delEntry(self, row, site):
+        ticket = self.getEntry(row, site)
+        parent = self.getParent(row, site)
+        if ticket is not None:
+            student = self._getStudent(row, site)
+            student.__parent__.logger.info('%s - Course ticket in %s removed: %s'
+                % (student.student_id, parent.level, ticket.code))
+            del parent[ticket.code]
+        return
+
     def checkConversion(self, row, mode='ignore'):
         """Validates all values in row.
@@ -552,5 +606,5 @@
     grok.name(util_name)
 
-    name = u'Payment Processor'
+    name = u'Student Payment Processor'
     iface = IStudentOnlinePayment
     factory_name = 'waeup.StudentOnlinePayment'
@@ -558,5 +612,12 @@
     location_fields = []
     additional_fields = ['p_id']
-    additional_headers = ['p_id']
+    additional_headers = []
+
+    def checkHeaders(self, headerfields, mode='ignore'):
+        super(StudentOnlinePaymentProcessor, self).checkHeaders(headerfields)
+        if mode in ('update', 'remove') and not 'p_id' in headerfields:
+            raise FatalCSVError(
+                "Need p_id for import in update and remove modes!")
+        return True
 
     def parentsExist(self, row, site):
@@ -573,13 +634,15 @@
         if payments is None:
             return None
+        p_id = row.get('p_id', None)
+        if p_id is None:
+            return None
         # We can use the hash symbol at the end of p_id in import files
         # to avoid annoying automatic number transformation
         # by Excel or Calc
-        p_id = row['p_id'].strip('#')
-        if p_id.startswith('p'):
-            entry = payments.get(p_id)
-        else:
-            # For data migration from old SRP
-            entry = payments.get('p' + p_id[6:])
+        p_id = p_id.strip('#')
+        if not p_id.startswith('p'):
+            # For data migration from old SRP only
+            p_id = 'p' + p_id[7:] + '0'
+        entry = payments.get(p_id)
         return entry
 
@@ -600,5 +663,5 @@
         if not p_id.startswith('p'):
             # For data migration from old SRP
-            obj.p_id = 'p' + p_id[6:]
+            obj.p_id = 'p' + p_id[7:] + '0'
             parent[obj.p_id] = obj
         else:
@@ -606,4 +669,14 @@
         return
 
+    def delEntry(self, row, site):
+        payment = self.getEntry(row, site)
+        parent = self.getParent(row, site)
+        if payment is not None:
+            student = self._getStudent(row, site)
+            student.__parent__.logger.info('%s - Payment ticket removed: %s'
+                % (student.student_id, payment.p_id))
+            del parent[payment.p_id]
+        return
+
     def checkConversion(self, row, mode='ignore'):
         """Validates all values in row.
@@ -613,5 +686,12 @@
 
         # We have to check p_id.
-        p_id = row['p_id'].strip('#')
+        p_id = row.get('p_id', None)
+        if not p_id:
+            timestamp = ("%d" % int(time()*10000))[1:]
+            p_id = "p%s" % timestamp
+            conv_dict['p_id'] = p_id
+            return errs, inv_errs, conv_dict
+        else:
+            p_id = p_id.strip('#')
         if p_id.startswith('p'):
             if not len(p_id) == 14:
